/*
 * Copyright 2011-2012 Arx Libertatis Team (see the AUTHORS file)
 *
 * This file is part of Arx Libertatis.
 *
 * Arx Libertatis is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * Arx Libertatis is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Arx Libertatis.  If not, see <http://www.gnu.org/licenses/>.
 */

#include "core/Version.h"

/*!
 * This file is automatically processed by cmake if the version or commit id changes.
 * Available variables:
 * - BASE_VERSION: The contents of the VERSION file.
 * - BASE_VERSION_COUNT: Number of lines in the VERSION file.
 * - BASE_VERSION_i: The i-th line of the VERSION file.
 * - GIT_COMMIT: The current git commit. This variable is not defined if there is no .git directory.
 * - GIT_COMMIT_PREFIX_i: The first i characters of the git commit (i=0..39).
 * For the exact syntax see the documentation of the configure_file() cmake command.
 */

/* #undef GIT_COMMIT */

#if 3 != 3
#error "Configure error - the VERSION file should specify exactly three non-empty lines!"
#endif

#ifdef GIT_COMMIT
#define GIT_SUFFIX " + "
#else
#define GIT_SUFFIX ""
#endif

const std::string version = "Arx Libertatis 1.0.2" GIT_SUFFIX;

const int tbg_version_id = 2;
